/* $Id: delivered_msg.h,v 1.2 2004/05/09 01:36:19 chris Exp $
 *
 * shapsim - Amorphous shape mapping computer simulator and analyzer.
 * Copyright (C) 2004 Chris Frost <frost@cs.virginia.edu>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __DELIVERED_MSG_H
#define __DELIVERED_MSG_H

#include "msg_content.h"
#include <memory>
#include <math.h>
//// Forward declare, including "Cell_data.h" breaks the build
// class Cell_data;

class delivered_msg
{
 public:
	delivered_msg();
	delivered_msg(const delivered_msg &dm);
	
	float get_direction() const;
	void  set_direction(float d);

	float get_strength() const;
	void  set_strength(float s);

	std::auto_ptr<msg_content> get_msg_content_copy() const;
	std::auto_ptr<msg_content> extract_msg_content();
	void set_msg_content(std::auto_ptr<msg_content> mc);

	/* Sender-data doesn't seem to be needed
	const Cell_data* get_sender() const;
	Cell_data* get_sender();
	void  set_sender(Cell_data *s);
	*/

 private:
	float direction;
	static const float direction_min = -2*M_PI, direction_max = 2*M_PI;

	float strength;
	static const float strength_min = 0, strength_max = 1;

	// Cell_data *sender;

	std::auto_ptr<msg_content> mc;
};

#endif // __DELIVERED_MSG_H
