#!/bin/bash

# $Id: gen-group_dist_data.sh,v 1.6 2004/05/12 05:08:02 chris Exp $
#
# shapsim - Amorphous shape mapping computer simulator and analyzer.
# Copyright (C) 2004 Chris Frost <frost@cs.virginia.edu>
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

CQES="0.1 0.11 0.12 0.13 0.15 0.2 0.3"
OUTFILE="group_dist.dat"
SHAPE="circle" # all shapes use same cell_layout, so doesn't matter
NUMCELLS=5000

echo -n "" > ${OUTFILE}

for cq in ${CQES}; do
#	echo -n "${nc} " >> ${OUTFILE}
	cat ${SHAPE}/cq-p${cq}-connections_stats \
		| grep -v "^<" \
		| awk '{print 100*_cq " " 100*$1/(_cq*_nc) " " $2}' _cq="${cq}" _nc="${NUMCELLS}" \
		>> ${OUTFILE};
done

echo "Remember to insert blank lines inbetween %cq in region groupings."
