/* $Id: msg_content.h,v 1.2 2004/05/09 01:36:19 chris Exp $
 *
 * shapsim - Amorphous shape mapping computer simulator and analyzer.
 * Copyright (C) 2004 Chris Frost <frost@cs.virginia.edu>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __MSG_CONTENT_H
#define __MSG_CONTENT_H

// msg_contents is a base class to be derived from for the simulation
// user to pass message content using messaging system.
class msg_content
{
 public:
	// TODO: ~msg_content()'s impl does nothing, can it be abstract?
	virtual ~msg_content(); 

	// We could use a virutal assn operator instead of clone(), but its use
	// is messy looking, so we don't.
	//	virtual msg_content& operator=(const msg_content &mc) = 0;
	virtual msg_content* clone() const = 0;
};

#endif // __MSG_CONTENT_H
