/* $Id: msg_sender.cpp,v 1.2 2004/05/09 01:36:19 chris Exp $
 *
 * shapsim - Amorphous shape mapping computer simulator and analyzer.
 * Copyright (C) 2004 Chris Frost <frost@cs.virginia.edu>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "msg_sender.h"
#include "todeliver_msg.h"
#include <vector>
using namespace std;

msg_sender::msg_sender(messenger *m, Cell_data *cd)
	: msg_messenger(m),
	  cell_data(cd)
{ assert(m && cd); }

msg_sender::msg_sender(const msg_sender &m)
	: msg_messenger(m.msg_messenger),
	  cell_data(m.cell_data)
{ assert(m.msg_messenger && m.cell_data); }

void msg_sender::send_msg(const todeliver_msg &m)
{ msg_messenger->deliver_msg(m, cell_data); }
