/* $Id: shape_sensor_factory.h,v 1.2 2004/05/09 01:36:20 chris Exp $
 *
 * shapsim - Amorphous shape mapping computer simulator and analyzer.
 * Copyright (C) 2004 Chris Frost <frost@cs.virginia.edu>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __SHAPE_SENSOR_FACTORY_H
#define __SHAPE_SENSOR_FACTORY_H

#include "shape_sensor.h"
#include "location.h"
#include <vector>
#include <string>

class shape_sensor_factory
{
public:
	shape_sensor_factory(const location    &space_size,
								const std::string &shape_description_filename);

	shape_sensor operator()(const location &sensor_locn);

 private:
	void load_shape_description(const std::string &shape_description_filename);

	std::vector< std::vector<bool> > shape_map;
	const unsigned int map_width, map_height;
};

#endif // __SHAPE_SENSOR_FACTORY_H
