/* $Id: todeliver_msg.cpp,v 1.2 2004/05/09 01:36:20 chris Exp $
 *
 * shapsim - Amorphous shape mapping computer simulator and analyzer.
 * Copyright (C) 2004 Chris Frost <frost@cs.virginia.edu>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include "todeliver_msg.h"
#include <memory>
using namespace std;

todeliver_msg::todeliver_msg()
	: mc(NULL)
{}

todeliver_msg::todeliver_msg(auto_ptr<msg_content> _mc)
	: mc(_mc)
{}

todeliver_msg::todeliver_msg(const todeliver_msg &tdm)
	: mc(tdm.get_msg_content_copy())
{}


auto_ptr<msg_content> todeliver_msg::get_msg_content_copy() const
{
	assert(mc.get());
	return auto_ptr<msg_content>(mc->clone());
}

auto_ptr<msg_content> todeliver_msg::extract_msg_content()
{ return mc; }

void todeliver_msg::set_msg_content(auto_ptr<msg_content> _mc)
{ mc = _mc; }
